/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package endpoints;

import java.util.List;
import resources.entities.Mehanicar;
import resources.entities.Zaposlen;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceException;
import javax.persistence.TypedQuery;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.GenericEntity;
import javax.ws.rs.core.Response;


/**
 *
 * @author Stefan
 */
@Path("mehanicari")
@Stateless
public class Mehanicari {
    
    @PersistenceContext(unitName = "kzpPU")
    EntityManager em;
    
    
    @GET
    @Path("{idMeh}")
    public Response getMehanicar(@PathParam("idMeh") int idMeh){
        Mehanicar mehanicar = em.find(Mehanicar.class, idMeh);
        if(mehanicar!=null)   
            return Response.status(Response.Status.OK).entity(mehanicar).build();
        return Response.status(Response.Status.NOT_FOUND).entity("Mehanicar ne postoji").build();
    }
    
     @GET
    public Response getMehanicari(@QueryParam("specijalnost") String specijalnost, @QueryParam("invert") Boolean invert){
        
        String query = "select m from Mehanicar m";
        
        if(specijalnost != null){
            if(invert != null && invert == true)
                query += " where m.specijalnost != :specijalnost";
            else query += " where m.specijalnost = :specijalnost";
        }
        
        TypedQuery<Mehanicar> tq = em.createQuery(query, Mehanicar.class);
        
        if(specijalnost != null) tq.setParameter("specijalnost", specijalnost);
        
        List<Mehanicar> mehanicari = tq.getResultList();
        
        if(mehanicari != null && !mehanicari.isEmpty())
            return Response.status(Response.Status.OK).entity(new GenericEntity<List<Mehanicar>>(mehanicari){}).build();
        
        return Response.status(Response.Status.NO_CONTENT).build();
    }
    
    @POST
    @Path("v1")
    public Response createMehanicar(Mehanicar mehanicar){
        try{
            Zaposlen zaposleni = em.find(Zaposlen.class, mehanicar.getIDZap());
            if(zaposleni != null)
                mehanicar.setZaposlen(zaposleni);
            em.persist(mehanicar);
            em.flush();
        }
        catch(PersistenceException e){
            return Response.status(Response.Status.INTERNAL_SERVER_ERROR).entity("Mehanicar vec postoji").build();
        }
        return Response.status(Response.Status.CREATED).entity("Mehanicar je kreiran").build();
    }
    
    @POST
    @Path("v2")
    public Response createMehanicar(
            @FormParam("id") int idZap, 
            @FormParam("imePrezime") String imePrezime, 
            @FormParam("staz") int staz,
            @FormParam("specijalnost") String specijalnost){
        Zaposlen zaposlen = new Zaposlen(idZap, imePrezime);
        zaposlen.setStaz(staz);
        Mehanicar mehanicar = new Mehanicar(idZap);
        mehanicar.setSpecijalnost(specijalnost);
        mehanicar.setZaposlen(zaposlen);
        try{
            em.persist(mehanicar);
            em.flush();
        }
        catch(PersistenceException e){
            return Response.status(Response.Status.INTERNAL_SERVER_ERROR).entity("Mehanicar vec postoji").build();
        }
        return Response.status(Response.Status.CREATED).entity("Mehanicar je kreiran").build();
    }
    
    @DELETE
    @Path("{idMeh}")
    public Response deleteMehanicar(@PathParam("idMeh") int idMeh){
        Mehanicar mehanicar = em.find(Mehanicar.class, idMeh);
        
        if(mehanicar == null)
            return Response.status(Response.Status.NO_CONTENT).build();
        
        if(!mehanicar.getPopravljaList().isEmpty())
            return Response.status(Response.Status.CONFLICT).entity("Mehanicaru prvo obrisati popravke").build();

        em.remove(mehanicar);
        
        return Response.status(Response.Status.NO_CONTENT).build();
    }
    
   
}
